DO I=0, N-1 
AB(19,10*I+1) = 2.E+0_DP*y(I+1)-2.E+0_DP*y(I)
AB(19,10*I+2) = 3.333333333333333E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(19,10*I+3) = 2.E-1_DP*(2.E+0_DP*y(I+1)-2.E+0_DP*y(I))
AB(19,10*I+4) = 1.4285714285714285E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(19,10*I+5) = 1.1111111111111112E-1_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
AB(19,10*I+6) = 9.090909090909092E-2_DP*(2.E+0_DP&
	&*y(I+1)-2.E+0_DP*y(I))
ENDDO 
DO I=1, N 

IF (10*I-19>0 ) AB(23,10*I-13) = 1.E+0_DP
IF ( N2>=10*I-3) AB(13,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(25,10*I-9) = -1.E+0_DP
IF ( N2>=10*I-3) AB(15,10*I+1) = 1.E+0_DP

IF (10*I-19>0 ) AB(24,10*I-13) = -1.E+0_DP
IF ( N2>=10*I-3) AB(14,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(24,10*I-8) = -1.E+0_DP
IF ( N2>=10*I-3) AB(14,10*I+2) = -1.E+0_DP
IF (10*I-18>0 ) AB(23,10*I-12) = (2.E+0_DP*y(I-1)-2.E&
	&+0_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=10*I-2) AB(13,10*I-2) = -2.E+0_DP
IF ( N2>=10*I-2) AB(25,10*I-8) = -2.E+0_DP
IF ( N2>=10*I-2) AB(15,10*I+2) = (2.E+0_DP*y(I)-2.E+0_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))

IF (10*I-19>0 ) AB(25,10*I-13) = 1.E+0_DP
IF ( N2>=10*I-3) AB(15,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(23,10*I-7) = -1.E+0_DP
IF ( N2>=10*I-3) AB(13,10*I+3) = 1.E+0_DP
IF (10*I-18>0 ) AB(24,10*I-12) = (6.E+0_DP*y(I-2)-6.E&
	&+0_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=10*I-2) AB(14,10*I-2) = -6.E+0_DP
IF ( N2>=10*I-2) AB(24,10*I-7) = -6.E+0_DP
IF ( N2>=10*I-2) AB(14,10*I+3) = (6.E+0_DP*y(I-1)-6.E+0_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))
IF (10*I-17>0 ) AB(23,10*I-11) = (y(I-1)*(1.2E+1_DP*y(I-1)-2.4E&
	&+1_DP*y(I-2))+1.2E+1_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=10*I-1) AB(13,10*I-1) = -1.2E+1_DP
IF ( N2>=10*I-1) AB(25,10*I-7) = -1.2E+1_DP
IF ( N2>=10*I-1) AB(15,10*I+3) = (y(I)*(1.2E+1_DP*y(I)-2.4E+1_DP&
	&*y(I-1))+1.2E+1_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2

IF (10*I-19>0 ) AB(26,10*I-13) = -1.E+0_DP
IF ( N2>=10*I-3) AB(16,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(22,10*I-6) = -1.E+0_DP
IF ( N2>=10*I-3) AB(12,10*I+4) = -1.E+0_DP
IF (10*I-18>0 ) AB(25,10*I-12) = (1.2E+1_DP*y(I-1)-1.2E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=10*I-2) AB(15,10*I-2) = -1.2E+1_DP
IF ( N2>=10*I-2) AB(23,10*I-6) = -1.2E+1_DP
IF ( N2>=10*I-2) AB(13,10*I+4) = (1.2E+1_DP*y(I)-1.2E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (10*I-17>0 ) AB(24,10*I-11) = (y(I-1)*(1.2E+2_DP&
	&*y(I-2)-6.E+1_DP*y(I-1))-6.E+1_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=10*I-1) AB(14,10*I-1) = -6.E+1_DP
IF ( N2>=10*I-1) AB(24,10*I-6) = -6.E+1_DP
IF ( N2>=10*I-1) AB(14,10*I+4) = (y(I)*(1.2E+2_DP*y(I-1)-6.E&
	&+1_DP*y(I))-6.E+1_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2
IF (10*I-16>0 ) AB(23,10*I-10) = (y(I-1)*(y(I-1)*(1.2E+2_DP&
	&*y(I-1)-3.6E+2_DP*y(I-2))+3.6E+2_DP*y(I-2)**2)-1.2E+2_DP*y(I-2)&
	&**3)/(y(I)-1.E+0_DP*y(I-1))**3
IF ( N2>=10*I) AB(13,10*I) = -1.2E+2_DP
IF ( N2>=10*I) AB(25,10*I-6) = -1.2E+2_DP
IF ( N2>=10*I) AB(15,10*I+4) = (y(I)*(y(I)*(1.2E+2_DP*y(I)-3.6E&
	&+2_DP*y(I-1))+3.6E+2_DP*y(I-1)**2)-1.2E+2_DP*y(I-1)**3)/(y(I&
	&+1)-1.E+0_DP*y(I))**3

IF (10*I-19>0 ) AB(27,10*I-13) = 1.E+0_DP
IF ( N2>=10*I-3) AB(17,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(21,10*I-5) = -1.E+0_DP
IF ( N2>=10*I-3) AB(11,10*I+5) = 1.E+0_DP
IF (10*I-18>0 ) AB(26,10*I-12) = (2.E+1_DP*y(I-2)-2.E&
	&+1_DP*y(I-1))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=10*I-2) AB(16,10*I-2) = -2.E+1_DP
IF ( N2>=10*I-2) AB(22,10*I-5) = -2.E+1_DP
IF ( N2>=10*I-2) AB(12,10*I+5) = (2.E+1_DP*y(I-1)-2.E+1_DP&
	&*y(I))/(y(I+1)-1.E+0_DP*y(I))
IF (10*I-17>0 ) AB(25,10*I-11) = (y(I-1)*(1.8E+2_DP*y(I-1)-3.6E&
	&+2_DP*y(I-2))+1.8E+2_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=10*I-1) AB(15,10*I-1) = -1.8E+2_DP
IF ( N2>=10*I-1) AB(23,10*I-5) = -1.8E+2_DP
IF ( N2>=10*I-1) AB(13,10*I+5) = (y(I)*(1.8E+2_DP*y(I)-3.6E+2_DP&
	&*y(I-1))+1.8E+2_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2
IF (10*I-16>0 ) AB(24,10*I-10) = (y(I-1)*(y(I-1)*(2.52E+3_DP&
	&*y(I-2)-8.4E+2_DP*y(I-1))-2.52E+3_DP*y(I-2)**2)+8.4E+2_DP*y(I-2)&
	&**3)/(y(I)-1.E+0_DP*y(I-1))**3
IF ( N2>=10*I) AB(14,10*I) = -8.4E+2_DP
IF ( N2>=10*I) AB(24,10*I-5) = -8.4E+2_DP
IF ( N2>=10*I) AB(14,10*I+5) = (y(I)*(y(I)*(2.52E+3_DP&
	&*y(I-1)-8.4E+2_DP*y(I))-2.52E+3_DP*y(I-1)**2)+8.4E+2_DP*y(I-1)**3)/(y(I&
	&+1)-1.E+0_DP*y(I))**3

IF (10*I-19>0 ) AB(28,10*I-13) = -1.E+0_DP
IF ( N2>=10*I-3) AB(18,10*I-3) = -1.E+0_DP
IF ( N2>=10*I-3) AB(20,10*I-4) = -1.E+0_DP
IF ( N2>=10*I-3) AB(10,10*I+6) = -1.E+0_DP
IF (10*I-18>0 ) AB(27,10*I-12) = (3.E+1_DP*y(I-1)-3.E&
	&+1_DP*y(I-2))/(y(I)-1.E+0_DP*y(I-1))
IF ( N2>=10*I-2) AB(17,10*I-2) = -3.E+1_DP
IF ( N2>=10*I-2) AB(21,10*I-4) = -3.E+1_DP
IF ( N2>=10*I-2) AB(11,10*I+6) = (3.E+1_DP*y(I)-3.E+1_DP&
	&*y(I-1))/(y(I+1)-1.E+0_DP*y(I))
IF (10*I-17>0 ) AB(26,10*I-11) = (y(I-1)*(8.4E+2_DP&
	&*y(I-2)-4.2E+2_DP*y(I-1))-4.2E+2_DP*y(I-2)**2)/(y(I)-1.E+0_DP*y(I-1))**2
IF ( N2>=10*I-1) AB(16,10*I-1) = -4.2E+2_DP
IF ( N2>=10*I-1) AB(22,10*I-4) = -4.2E+2_DP
IF ( N2>=10*I-1) AB(12,10*I+6) = (y(I)*(8.4E+2_DP*y(I-1)-4.2E&
	&+2_DP*y(I))-4.2E+2_DP*y(I-1)**2)/(y(I+1)-1.E+0_DP*y(I))**2
IF (10*I-16>0 ) AB(25,10*I-10) = (y(I-1)*(y(I-1)*(3.36E&
	&+3_DP*y(I-1)-1.008E+4_DP*y(I-2))+1.008E+4_DP*y(I-2)**2)-3.36E+3_DP&
	&*y(I-2)**3)/(y(I)-1.E+0_DP*y(I-1))**3
IF ( N2>=10*I) AB(15,10*I) = -3.36E+3_DP
IF ( N2>=10*I) AB(23,10*I-4) = -3.36E+3_DP
IF ( N2>=10*I) AB(13,10*I+6) = (y(I)*(y(I)*(3.36E+3_DP&
	&*y(I)-1.008E+4_DP*y(I-1))+1.008E+4_DP*y(I-1)**2)-3.36E+3_DP*y(I-1)*&
	&*3)/(y(I+1)-1.E+0_DP*y(I))**3
ENDDO 
